#!/bin/bash
NODE_EXPORTER_FOLDER="/var/lib/prometheus/node-exporter"
METRICS_FILE_NAME="k8s_gpu_exporter_metrics.prom"
K8S_GPU_METRICS_PATH="${NODE_EXPORTER_FOLDER}/${METRICS_FILE_NAME}"
TMP_METRICS_PATH=$(mktemp)

# Create temporary log file
LOGFILE=$(mktemp)
GPU_TEMP=$( nvidia-smi -q --display=Temperature  2>/dev/null | grep "GPU Current Temp" | awk '$5 > m || NR == 1 { m = $5} END { print m }')
GPU_PERF=$( nvidia-smi -q --display=Performance  2>/dev/null | grep "Performance State" |  awk '{print substr($4,2); }' | awk '$1 > m || NR == 1 { m = $1} END { print m }')

# Calculate metrics
TIMESTAMP=$(date +%s)

# Write the status of the K8s gpu nodes
echo "# HELP Reports the status of the K8s gpu nodes." >> "${TMP_METRICS_PATH}"
echo "# TYPE skao_k8s_gpu_status gauge" >> "${TMP_METRICS_PATH}"
echo "skao_k8s_gpu_status{datacentre=\"{{ prometheus_datacentre }}\", check=\"temperature\"} ${GPU_TEMP}" >> "${TMP_METRICS_PATH}"
echo "skao_k8s_gpu_status{datacentre=\"{{ prometheus_datacentre }}\", check=\"performance\"} ${GPU_PERF}" >> "${TMP_METRICS_PATH}"

# Write the timestamp of this check, useful to check if the cronjob is running normally
echo "# HELP skao_k8s_gpu_status_update_seconds The timestamp of the last K8s gpu node metrics update." >> "${TMP_METRICS_PATH}"
echo "# TYPE skao_k8s_gpu_status_update_seconds counter" >> "${TMP_METRICS_PATH}"
echo "skao_k8s_gpu_status_update_seconds ${TIMESTAMP}" >> "${TMP_METRICS_PATH}"

# Make metrics file world readable
chmod 644 "${TMP_METRICS_PATH}"

# Atomically update the prometheus metrics file
mv "${TMP_METRICS_PATH}" "${K8S_GPU_METRICS_PATH}"
rm $LOGFILE
